%**************************************************************************
%University of British Columbia
%Vanessa Alviarez
%Comparative Advantage
%Journal of International Economics 
%Last Update: 2019
%**************************************************************************


%=======================================================================
%Costinot procedure 
%=======================================================================
%FIRST: let's compute for the Z's: start with the actual Z's
%Then compute the prices until convergency. Then calculate the pi, Q and Y,
%and solve for Z's

%This will give you the set of T's in a situation where all the other
%parameters are as estimated. If we need to make any other parameter counterfactual, this has to be
%recalculated. 


%--------------------------------------------------------------------------
%Counterfactuals for the T's (m adjusted)
%--------------------------------------------------------------------------
clear all
addpath('L:/Dropbox (UBC-Umich)/MNC_CA/Data and Replication Files/matlab_code')

clear all 
load 'parameters_1a.mat' N J 
Z_storage=ones(N,20,N);
Z_costinot=ones(N,N);
T_mp_costinot=ones(N,J+1,N);
save('Tmp_costinot_m_adjusted.mat')

load 'parameters_1a.mat' T_mp

for ref=1:32
 tic;   
  ref
save('Tmp_costinot_m_adjusted.mat', 'ref', '-append');
clear all
load 'parameters_1a.mat'
load 'equilibrium_full_model.mat'
load 'Tmp_costinot_m_adjusted.mat' ref
wages_equi0=wages_equi;
r_capital_equi0=r_capital_equi;


T_mp_storage2=T_mp;
T_mp_storage=T_mp;
Z=ones(N,J+1);
geo=geomean(T_mp_storage(:,1:J+1),2);
for j=1:J+1
  Z(:,j)=geo./geo(ref,1);
end
T_mp_ref=T_mp_storage;
for n=1:N
   T_mp_ref(n,1:J+1)=T_mp_storage(ref,1:J+1);
end
T_mp=T_mp_storage;
for n=1:N
   T_mp(n,1:J+1)=Z(n,1:J+1).*T_mp_storage(ref,1:J+1);
end
load 'Tmp_costinot_m_adjusted.mat' Z_storage  

for count=1:20
ref
count
run Equilibrium_mp_loop_prices_fv.m; 
run Equilibrium_mp_loop_Zs_fv.m; %From the equilibrium we set Z for non-tradables to have the same values across countries and equal to one.
%in the counterfactual

Z_storage(:,count,ref)=X_labor;
end

load 'Tmp_costinot_m_adjusted.mat' Z_costinot T_mp_costinot
Z_costinot(:,ref)=X_labor; 
T_mp_costinot(:,:,ref)=T_mp; 
save('Tmp_costinot_m_adjusted.mat', 'Z_storage', 'Z_costinot', 'T_mp_costinot', '-append');
toc;
end

save('book_costinot_m_adjusted_fv.mat'); %now it excludes non-tradables




%================================================================================================
%Counterfactual (country by country) only counterfactual parameter is the
%COSTINOT T's 
%================================================================================================
clear all
addpath('L:\Dropbox (UBC-Umich)\MNC_CA\Data and Replication Files\matlab_code')

%Counterfactual 1: (T's equals across sectors) using CES and capital model
%--------------------------------------------------------------------------
clear all
load 'parameters_1a.mat' N J 
wages_count=ones(N,N);
r_capital_count=ones(N,N);
PIndex_count=ones(N,N);
Atkinson_mp_count=ones(N,N);
Atkinson_trade_count=ones(N,N);
domestic_share_count=ones(N,N);
domestic_share_tradable_count=ones(N,N);
domestic_share_sector_count=ones(N,J+1,N);
local_share_count=ones(N,N);
local_share_tradable_count=ones(N,N);
local_share_nontradable_count=ones(N,N);
local_share_sector_count=ones(N,J+1,N);
GAINS_baseline_count=ones(N,3,N);
domestic_share_nomp_count=ones(N,N); 
domestic_share_nomp_tradable_count=ones(N,N); 
domestic_share_nomp_sector_count=ones(N,J+1,N);

GAINS_uni0_count=ones(N,3,N);
GAINS_uni1_count=ones(N,3,N); 
GAINS_uni2_count=ones(N,3,N); 
GAINS_uni3_count=ones(N,3,N);
GAINS_multi0_count=ones(N,3,N);
GAINS_multi1_count=ones(N,3,N);
GAINS_multi2_count=ones(N,3,N);
GAINS_multi3_count=ones(N,3,N);

save('Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat')


for ref=1:32
ref
    
ref=ref; 
save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'ref');
  
clear all
load 'parameters_1a.mat' 
save 'parameters_welfare_a.mat'
load 'equilibrium_full_model.mat' T_agg_all_T T_agg_all T_agg_all_T_savg T_agg_all_savg
load 'Tmp_costinot_m_adjusted.mat' T_mp_costinot

save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'T_mp_costinot', 'T_agg_all_T', 'T_agg_all', 'T_agg_all_T_savg', 'T_agg_all_savg', '-append');
load 'Equilibrium_avg_Tmp_costinot_m_adjusted.mat' ref; 

T_mp=T_mp_costinot(:,:,ref); 


h1=h.^(-theta);
T_sq_trade=ones(N,J+1); 
for j=1:J+1
T_sq_trade(:,j)=(h1(:,:,j))*T_mp(:,j);  
end
Atkinson_T_mp=1-(geomean(T_mp(:,1:J),2)./mean(T_mp(:,1:J),2));
Atkinson_T_sq=1-(geomean(T_sq_trade(:,1:J),2)./mean(T_sq_trade(:,1:J),2));
Atkinson_T=[Atkinson_T_mp Atkinson_T_sq];

save('parameters_welfare_a.mat', 'T_mp', 'T_sq_trade', 'Atkinson_T', '-append');
save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'Atkinson_T', '-append');

run Equilibrium_mp_complete_loop_CES.m;
load 'Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat' wages_count r_capital_count PIndex_count
wages_equi=wages_sim(:,end-1);
r_capital_equi=r_capital_sim(:,end-1);
wages_count(:,ref)=wages_sim(:,end-1);
r_capital_count(:,ref)=r_capital_sim(:,end-1);
PIndex_count(:,ref)=PIndex;
save('Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat', 'wages_count', 'r_capital_count', 'PIndex_count', '-append');
save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'wages', 'r_capital', 'PIndex', '-append');

run trade_mp_share.m;
load 'equilibrium_full_model.mat' output_share_all output_share_T beta_T_NT beta_all betas_nj D_multi_nolink D_multi D_uni si_multi;

load 'Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat' Atkinson_mp_count Atkinson_trade_count domestic_share_count domestic_share_tradable_count domestic_share_sector_count local_share_count local_share_tradable_count local_share_nontradable_count local_share_sector_count
Atkinson_mp_count(:,ref)=Atkinson_mp;
Atkinson_trade_count(:,ref)=Atkinson_trade;
domestic_share_count(:,ref)=domestic_share;
domestic_share_tradable_count(:,ref)=domestic_share_tradable;
domestic_share_sector_count(:,:,ref)=domestic_share_sector;
local_share_count(:,ref)=local_share;
local_share_tradable_count(:,ref)=local_share_tradable;
local_share_nontradable_count(:,ref)=local_share_nontradable;
local_share_sector_count(:,:,ref)=local_share_sector;
save ('Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat', 'Atkinson_mp_count', 'Atkinson_trade_count', 'domestic_share_count', 'domestic_share_tradable_count', 'domestic_share_sector_count', 'local_share_count', 'local_share_tradable_count', 'local_share_nontradable_count', 'local_share_sector_count', '-append');
save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'output_share_all', 'output_share_T', 'beta_T_NT', 'beta_all', 'betas_nj', 'D_multi_nolink', 'D_multi', 'D_uni', 'si_multi', 'Atkinson_mp', 'Atkinson_trade', 'domestic_share', 'domestic_share_tradable', 'domestic_share_sector', 'local_share', 'local_share_tradable', 'local_share_nontradable', 'local_share_sector', '-append');

%---------------------------------------------------------------
%Run the welfare analysis
%Index 1 (CES, capital), Index 2 (Cobb Douglas, capital), Index 3 (CES, without capital), Index 4 (Cobb Douglas, without capital)
%---------------------------------------------------------------
index=1; 
run welfare_analysis.m;

load 'Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat' GAINS_baseline_count domestic_share_nomp_count domestic_share_nomp_tradable_count domestic_share_nomp_sector_count
GAINS_baseline_count(:,:,ref)=GAINS_baseline;
domestic_share_nomp_count(:,ref)=domestic_share_nomp;
domestic_share_nomp_tradable_count(:,ref)=domestic_share_nomp_tradable;
domestic_share_nomp_sector_count(:,:,ref)=domestic_share_nomp_sector;
save ('Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat', 'GAINS_baseline_count', 'domestic_share_nomp_count', 'domestic_share_nomp_tradable_count', 'domestic_share_nomp_sector_count', '-append');

save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'GAINS_baseline', 'domestic_share_nomp', 'domestic_share_nomp_tradable', 'domestic_share_nomp_sector', '-append');

%---------------------------------------------------------------
%Model based welfare analysis 
%---------------------------------------------------------------
clear all 
load 'parameters_welfare_a.mat' 
load 'Equilibrium_avg_Tmp_costinot_m_adjusted.mat';  
run Model_based_formulas.m; 
load 'Equilibrium_avg_Tmp_costinot_m_adjusted.mat' ref

load 'Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat' GAINS_uni0_count GAINS_uni1_count GAINS_uni2_count GAINS_uni3_count GAINS_multi0_count GAINS_multi1_count GAINS_multi2_count GAINS_multi3_count
GAINS_uni0_count(:,:,ref)=GAINS_uni0;
GAINS_uni1_count(:,:,ref)=GAINS_uni1;
GAINS_uni2_count(:,:,ref)=GAINS_uni2;
GAINS_uni3_count(:,:,ref)=GAINS_uni3; 
GAINS_multi0_count(:,:,ref)=GAINS_multi0;
GAINS_multi1_count(:,:,ref)=GAINS_multi1;
GAINS_multi2_count(:,:,ref)=GAINS_multi2;
GAINS_multi3_count(:,:,ref)=GAINS_multi3;
save('Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat', 'GAINS_uni0_count', 'GAINS_uni1_count', 'GAINS_uni2_count', 'GAINS_uni3_count', 'GAINS_multi0_count', 'GAINS_multi1_count', 'GAINS_multi2_count', 'GAINS_multi3_count', '-append');
save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'GAINS_uni0', 'GAINS_uni1', 'GAINS_uni2', 'GAINS_uni3', 'GAINS_multi0', 'GAINS_multi1', 'GAINS_multi2', 'GAINS_multi3', '-append');

end

%---------------------------------------------------------------------------
%Arranging the matrix propely for analysis
%---------------------------------------------------------------------------
clear all
load 'equilibrium_full_model.mat'
PIndex_equi=PIndex;
load 'Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat'
load 'Tmp_costinot_m_adjusted'

wages_count2=diag(wages_count);
r_capital_count2=diag(r_capital_count);
PIndex_count2=diag(PIndex_count);

%Trade and MP shares 
domestic_share_count2=diag(domestic_share_count);
domestic_share_nomp_count2=diag(domestic_share_nomp_count);

domestic_share_tradable_count2=diag(domestic_share_tradable_count);
local_share_count2=diag(local_share_count);
local_share_tradable_count2=diag(local_share_tradable_count);
local_share_nontradable_count2=diag(local_share_nontradable_count);

%Trade and MP Akinson 
Atkinson_mp_count2=diag(Atkinson_mp_count);
Atkinson_trade_count2=diag(Atkinson_trade_count);

%Trade
for n=1:N
GAINS_baseline_count_trade(:,n)=GAINS_baseline_count(:,1,n);
GAINS_uni0_count_trade(:,n)=GAINS_uni0_count(:,1,n);
GAINS_uni1_count_trade(:,n)=GAINS_uni1_count(:,1,n);
GAINS_uni2_count_trade(:,n)=GAINS_uni2_count(:,1,n);
GAINS_uni3_count_trade(:,n)=GAINS_uni3_count(:,1,n);
GAINS_multi0_count_trade(:,n)=GAINS_multi0_count(:,1,n);
GAINS_multi1_count_trade(:,n)=GAINS_multi1_count(:,1,n);
GAINS_multi2_count_trade(:,n)=GAINS_multi2_count(:,1,n);
GAINS_multi3_count_trade(:,n)=GAINS_multi3_count(:,1,n);
end

GAINS_baseline_count_trade_2=diag(GAINS_baseline_count_trade); 
GAINS_uni0_count_trade_2=diag(GAINS_uni0_count_trade); 
GAINS_uni1_count_trade_2=diag(GAINS_uni1_count_trade); 
GAINS_uni2_count_trade_2=diag(GAINS_uni2_count_trade); 
GAINS_uni3_count_trade_2=diag(GAINS_uni3_count_trade); 
GAINS_multi0_count_trade_2=diag(GAINS_multi0_count_trade); 
GAINS_multi1_count_trade_2=diag(GAINS_multi1_count_trade); 
GAINS_multi2_count_trade_2=diag(GAINS_multi2_count_trade); 
GAINS_multi3_count_trade_2=diag(GAINS_multi3_count_trade); 

%MP
for n=1:N
GAINS_baseline_count_mp(:,n)=GAINS_baseline_count(:,2,n);
GAINS_uni0_count_mp(:,n)=GAINS_uni0_count(:,2,n);
GAINS_uni1_count_mp(:,n)=GAINS_uni1_count(:,2,n);
GAINS_uni2_count_mp(:,n)=GAINS_uni2_count(:,2,n);
GAINS_uni3_count_mp(:,n)=GAINS_uni3_count(:,2,n);
GAINS_multi0_count_mp(:,n)=GAINS_multi0_count(:,2,n);
GAINS_multi1_count_mp(:,n)=GAINS_multi1_count(:,2,n);
GAINS_multi2_count_mp(:,n)=GAINS_multi2_count(:,2,n);
GAINS_multi3_count_mp(:,n)=GAINS_multi3_count(:,2,n);
end

GAINS_baseline_count_mp_2=diag(GAINS_baseline_count_mp); 
GAINS_uni0_count_mp_2=diag(GAINS_uni0_count_mp); 
GAINS_uni1_count_mp_2=diag(GAINS_uni1_count_mp); 
GAINS_uni2_count_mp_2=diag(GAINS_uni2_count_mp); 
GAINS_uni3_count_mp_2=diag(GAINS_uni3_count_mp); 
GAINS_multi0_count_mp_2=diag(GAINS_multi0_count_mp); 
GAINS_multi1_count_mp_2=diag(GAINS_multi1_count_mp); 
GAINS_multi2_count_mp_2=diag(GAINS_multi2_count_mp); 
GAINS_multi3_count_mp_2=diag(GAINS_multi3_count_mp); 

%Openness
for n=1:N
GAINS_baseline_count_openness(:,n)=GAINS_baseline_count(:,3,n);
GAINS_uni0_count_openness(:,n)=GAINS_uni0_count(:,3,n);
GAINS_uni1_count_openness(:,n)=GAINS_uni1_count(:,3,n);
GAINS_uni2_count_openness(:,n)=GAINS_uni2_count(:,3,n);
GAINS_uni3_count_openness(:,n)=GAINS_uni3_count(:,3,n);
GAINS_multi0_count_openness(:,n)=GAINS_multi0_count(:,3,n);
GAINS_multi1_count_openness(:,n)=GAINS_multi1_count(:,3,n);
GAINS_multi2_count_openness(:,n)=GAINS_multi2_count(:,3,n);
GAINS_multi3_count_openness(:,n)=GAINS_multi3_count(:,3,n);
end

GAINS_baseline_count_openness_2=diag(GAINS_baseline_count_openness); 
GAINS_uni0_count_openness_2=diag(GAINS_uni0_count_openness); 
GAINS_uni1_count_openness_2=diag(GAINS_uni1_count_openness); 
GAINS_uni2_count_openness_2=diag(GAINS_uni2_count_openness); 
GAINS_uni3_count_openness_2=diag(GAINS_uni3_count_openness); 
GAINS_multi0_count_openness_2=diag(GAINS_multi0_count_openness); 
GAINS_multi1_count_openness_2=diag(GAINS_multi1_count_openness); 
GAINS_multi2_count_openness_2=diag(GAINS_multi2_count_openness); 
GAINS_multi3_count_openness_2=diag(GAINS_multi3_count_openness); 

GAINS_baseline_count_2=[GAINS_baseline_count_trade_2 GAINS_baseline_count_mp_2 GAINS_baseline_count_openness_2]; 
GAINS_uni0_count_2=[GAINS_uni0_count_trade_2 GAINS_uni0_count_mp_2 GAINS_uni0_count_openness_2];
GAINS_uni1_count_2=[GAINS_uni1_count_trade_2 GAINS_uni1_count_mp_2 GAINS_uni1_count_openness_2 ];
GAINS_uni2_count_2=[GAINS_uni2_count_trade_2 GAINS_uni2_count_mp_2 GAINS_uni2_count_openness_2];
GAINS_uni3_count_2=[GAINS_uni3_count_trade_2 GAINS_uni3_count_mp_2 GAINS_uni3_count_openness_2];
GAINS_multi0_count_2=[GAINS_multi0_count_trade_2 GAINS_multi0_count_mp_2 GAINS_multi0_count_openness_2];
GAINS_multi1_count_2=[GAINS_multi1_count_trade_2 GAINS_multi1_count_mp_2 GAINS_multi1_count_openness_2];
GAINS_multi2_count_2=[GAINS_multi2_count_trade_2 GAINS_multi2_count_mp_2 GAINS_multi2_count_openness_2];
GAINS_multi3_count_2=[GAINS_multi3_count_trade_2 GAINS_multi3_count_mp_2 GAINS_multi3_count_openness_2];

real_wage_equi=wages_equi./PIndex_equi; 
real_wage_count=wages_count2./PIndex_count2; 
real_wage_change=(real_wage_count./real_wage_equi)-1; 

load 'parameters_1a.mat' capital labor 
capital_pc=capital./labor;
real_income_equi=(wages_equi+capital_pc.*r_capital_equi)./PIndex;
real_income_count=(wages_count2+capital_pc.*r_capital_count2)./PIndex_count2;
real_income_change=(real_income_count./real_income_equi)-1; 

save('Equilibrium_avg_Tmp_costinot_m_adjusted.mat', 'wages_count2', 'r_capital_count2', 'PIndex_count2', 'domestic_share_count2', 'domestic_share_tradable_count2', 'local_share_count2', 'local_share_tradable_count2', 'local_share_nontradable_count2', 'Atkinson_mp_count2', 'Atkinson_trade_count2', 'GAINS_baseline_count_2', 'GAINS_uni0_count_2', 'GAINS_uni1_count_2', 'GAINS_uni2_count_2', 'GAINS_uni3_count_2', 'GAINS_multi0_count_2', 'GAINS_multi1_count_2', 'GAINS_multi2_count_2', 'GAINS_multi3_count_2', '-append');
save('Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat', 'wages_count2', 'r_capital_count2', 'PIndex_count2', 'domestic_share_count2', 'domestic_share_tradable_count2', 'local_share_count2', 'local_share_tradable_count2', 'local_share_nontradable_count2', 'Atkinson_mp_count2', 'Atkinson_trade_count2', 'GAINS_baseline_count_2', 'GAINS_uni0_count_2', 'GAINS_uni1_count_2', 'GAINS_uni2_count_2', 'GAINS_uni3_count_2', 'GAINS_multi0_count_2', 'GAINS_multi1_count_2', 'GAINS_multi2_count_2', 'GAINS_multi3_count_2', '-append');

clear all
load 'Equilibrium_avg_Tmp_costinot_m_adjusted.mat' 
load 'Equilibrium_avg_Tmp_costinot_savematrix_m_adjusted.mat'
load 'parameters_1a.mat' h
save('Equilibrium_avg_Tmp_costinot_m_adjusted_fv.mat')



%----------------------------------------------------------------------------
%Basic Analysis (for the equilibrium level of h and d and other parameters
%rather than T's
%----------------------------------------------------------------------------
%FIRST COUNTERFACTUAL%: 
%-First show the redution in the new Atkinson related to the original one
%ones the T's are homogeneous. 
%-Graph per country how the adjusted change in GMP (Figure A.6 in the
%paper) 
%Correlate with initial Atkinson. (Figure 6 in the paper) 

%-------------------------------------------------------------------------
clear all
load 'Equilibrium_avg_Tmp_costinot_m_adjusted_fv.mat'
load 'equilibrium_full_model.mat'



%----------------------------------------------------
%-First show the redution in the new Atkinson related to the original one
%ones the T's are homogeneous. Figure A.6 in the paper]
%----------------------------------------------------
g1=[Atkinson_mp reshape(Atkinson_mp_count2(:,:,1),N,1)];

subplot(1,2,2) 
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};

corr(g1(:,1),g1(:,2))
scatter(g1(:,1),g1(:,2),'b','.')
line([0,0.35],[0,0.35],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
xlabel('Atkinson MP shares');
ylabel('Atkinson MP shares (No Comparative Advantage)');
labelpoints(g1(:,1),g1(:,2), labels, 'FontSize', 7);
set(gcf,'color','w');
saveas(gcf,'Atkinson_mp_c1','eps')
saveas(gcf,'Atkinson_mp_c1','png')


g1=[Atkinson_trade Atkinson_trade_count2(:,:,1)];
subplot(1,2,1) 
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(g1(:,1),g1(:,2))
scatter(g1(:,1),g1(:,2),'b','.')
line([0,0.4],[0,0.4],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
xlabel('Atkinson trade shares');
ylabel('Atkinson trade shares (No Comparative Advantage)');
labelpoints(g1(:,1),g1(:,2), labels, 'FontSize', 7);
set(gcf,'color','w');
saveas(gcf,'Atkinson_trade_c1','eps')
saveas(gcf,'Atkinson_trade_c1','png')



%----------------------------------------------------
%-Graph per country how the adjusted change in GMP correlate with initial Atkinson. 
%----------------------------------------------------
a1=[GAINS_multi2(:,2) GAINS_multi2_count_2(:,2)];
a1_v3=(a1(:,2)./a1(:,1))-1;

b1=ones(2,J+1);
for j=1:J+1;
b0=sort(T_mp(:,j));
b1(:,j)=[b0(end-1); b0(end)];
end
b2=mean(b1);

T_mp_front=ones(N,J+1);
for n=1:N
T_mp_front(n,:)=T_mp(n,:)./b2;
end
Atkinson_T_mp_front_all=1-(geomean(T_mp_front(:,1:J+1),2)./mean(T_mp_front(:,1:J+1),2));
Atkinson_T_mp_front_tradable=1-(geomean(T_mp_front(:,1:J),2)./mean(T_mp_front(:,1:J),2));

g1=[Atkinson_T_mp_front_tradable a1_v3];

subplot(1,3,1) 
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(g1(:,1),g1(:,2))
scatter(g1(:,1),g1(:,2),'b','.')
lsline
hline = refline([0 0]);
xlabel('Atkinson T');
ylabel('Gains from MP (% Change)');
set(gcf,'color','w');
labelpoints(g1(:,1),g1(:,2), labels, 'FontSize', 6);


%------------------------------------------------------------------------
a1=[GAINS_multi2(:,1) GAINS_multi2_count_2(:,1)];
a1_v3=(a1(:,2)./a1(:,1))-1;

b1=ones(2,J+1);
for j=1:J+1;
b0=sort(T_mp(:,j));
b1(:,j)=[b0(end-1); b0(end)];
end
b2=mean(b1);

T_mp_front=ones(N,J+1);
for n=1:N
T_mp_front(n,:)=T_mp(n,:)./b2;
end
Atkinson_T_mp_front_all=1-(geomean(T_mp_front(:,1:J+1),2)./mean(T_mp_front(:,1:J+1),2));
Atkinson_T_mp_front_tradable=1-(geomean(T_mp_front(:,1:J),2)./mean(T_mp_front(:,1:J),2));

g1=[Atkinson_T_mp_front_all a1_v3];
subplot(1,3,2) 
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(g1(:,1),g1(:,2))
scatter(g1(:,1),g1(:,2),'b','.')
lsline
hline = refline([0 0]);
xlabel('Atkinson T');
ylabel('Gains from Trade (% Change)');
set(gcf,'color','w');
labelpoints(g1(:,1),g1(:,2), labels, 'FontSize', 6);


%------------------------------------------------------------------------
a1=[GAINS_multi2(:,3) GAINS_multi2_count_2(:,3)];
a1_v3=(a1(:,2)./a1(:,1))-1;

b1=ones(2,J+1);
for j=1:J+1;
b0=sort(T_mp(:,j));
b1(:,j)=[b0(end-1); b0(end)];
end
b2=mean(b1);

T_mp_front=ones(N,J+1);
for n=1:N
T_mp_front(n,:)=T_mp(n,:)./b2;
end
Atkinson_T_mp_front_all=1-(geomean(T_mp_front(:,1:J+1),2)./mean(T_mp_front(:,1:J+1),2));
Atkinson_T_mp_front_tradable=1-(geomean(T_mp_front(:,1:J),2)./mean(T_mp_front(:,1:J),2));

g1=[Atkinson_T_mp_front_all a1_v3];
subplot(1,3,3) 
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(g1(:,1),g1(:,2))
scatter(g1(:,1),g1(:,2),'b','.')
lsline
hline = refline([0 0]);
xlabel('Atkinson T');
ylabel('Gains from Openness (% Change)');
set(gcf,'color','w');
labelpoints(g1(:,1),g1(:,2), labels, 'FontSize', 6);

saveas(gcf,'Atkinson_gains_change','eps')
saveas(gcf,'Atkinson_gains_change','png')





%----------------------------------------------------
%-Second explain how large are those changes (adjusted and unadjsuted), per country and on average. 
%----------------------------------------------------

%MP
%--------------------------------------
a1=[GAINS_multi2(:,2) GAINS_multi2_count_2(:,2) GAINS_multi3_count_2(:,2)];
a1_v2=(a1(:,3)./a1(:,1))-1; %conditional
a1_v3=(a1(:,2)./a1(:,1))-1; %unconditional

a1_v2_pp=(a1(:,3)-a1(:,1));
a1_v3_pp=(a1(:,2)-a1(:,1));

g1=[GAINS_multi2(:,2) a1_v3 a1_v2 a1_v3_pp a1_v2_pp].*100;
mean(g1,1)


%Openness
%--------------------------------------
a1=[GAINS_multi2(:,3) GAINS_multi2_count_2(:,3) GAINS_multi3_count_2(:,3)];
a1_v2=(a1(:,3)./a1(:,1))-1; %conditional
a1_v3=(a1(:,2)./a1(:,1))-1; %unconditional

a1_v2_pp=(a1(:,3)-a1(:,1));
a1_v3_pp=(a1(:,2)-a1(:,1));

g1=[GAINS_multi2(:,3) a1_v3 a1_v2 a1_v3_pp a1_v2_pp].*100;
mean(g1,1)


%Trade
%--------------------------------------
a1=[GAINS_multi2(:,1) GAINS_multi2_count_2(:,1) GAINS_multi3_count_2(:,1)];
a1_v2=(a1(:,3)./a1(:,1))-1; %conditional
a1_v3=(a1(:,2)./a1(:,1))-1; %unconditional

a1_v2_pp=(a1(:,3)-a1(:,1));
a1_v3_pp=(a1(:,2)-a1(:,1));

g1=[GAINS_multi2(:,1) a1_v3 a1_v2 a1_v3_pp a1_v2_pp].*100;
a=[16; 20];
g1(a,:)=[]; %This is the table we want to show. 
mean(g1,1)


%Wages
%--------------------------------------
load 'parameters_1a.mat'  capital labor
capital_pc=capital./labor;

real_wage=(wages_count2)./PIndex_count2;
real_income=(wages_count2+capital_pc.*r_capital_count2)./PIndex_count2;
real_wage_equi=(wages_equi)./PIndex;
real_income_equi=(wages_equi+capital_pc.*r_capital_equi)./PIndex;

a1=[real_wage_equi real_wage];
a1_v2=((a1(:,2)./a1(:,1))-1); %conditional
a1=[real_income_equi real_income];
a2_v2=((a1(:,2)./a1(:,1))-1); %conditional

g1=[a1_v2 a2_v2].*100;
mean(g1,1)


%Chages in aggregate trade and MP share: 
%--------------------------------------
domestic_share_change=((domestic_share_count2./domestic_share)-1); 
local_share_change=((local_share_count2./local_share)-1); 
local_share_tradable_change=((local_share_tradable_count2./local_share_tradable)-1); 
local_share_nontradable_change=((local_share_nontradable_count2./local_share_nontradable)-1); 

g1=[domestic_share domestic_share_change local_share local_share_change local_share_tradable_change local_share_nontradable_change].*100;


