%==========================================================================
%Equilibrium for CES, Capital
%==========================================================================

for s=1:iter-1;      
s    
%Term 1: w^(alpha*beta) for every sector
%---------------------------------------------
wages=wages_sim(:,s);
wages_1=ones(N,1,J+1);
for j=1:J+1
wages_1(:,1,j)=wages;
end
term_1=wages_1.^alpha_beta_3;

%Term 2: r^(1-alpha)*beta for every sector
%---------------------------------------------
r_capital=r_capital_sim(:,s);
r_capital_1=ones(N,1,J+1);
for j=1:J+1
r_capital_1(:,1,j)=r_capital;
end
term_2=r_capital_1.^alpha_beta_7;
%term_2=1;

%Term 3: P
%---------------------------------------------
term_3=ones(N,1,J+1);
p=p_sim(:,:,:,s);
for j=1:J+1
A=ones(N,1);
for k=1:J+1
B=p(:,1,k).^((1-beta_1(j)).*gamma_a(k,j));
A=A.*B;
end
term_3(:,1,j)=A;
clear A
end

%Term 4: Unit Cost
%---------------------------------------------
c=term_1.*term_2.*term_3;
cost=c;
clear term_1 term_2 term_3

%--------------------------------------------------------------------------
%Equation 2: phis=c*h*d and pi. (it correspond to equation xx) 
%--------------------------------------------------------------------------
%Decision is constructing separate tradable and nontradable phi

d3=ones(N,N,N,J+1);
for j=1:J+1
    for n=1:N
        d3(:,:,n,j)=d(:,:,j);
    end
end
d3=d3.^(-theta/(1-rho));

h3=ones(N,N,N,J+1);
for j=1:J+1
    for n=1:N
      for  m=1:N
        h3(m,:,n,j)=h(:,n,j)';
      end
    end
end
h3=h3.^(-theta/(1-rho));

c3=ones(N,N,N,J+1);
for j=1:J+1
    for n=1:N
        for m=1:N
        c3(m,:,n,j)=c(:,1,j)';
        end
    end
end
c3=c3.^(-theta/(1-rho));

%phis=ones(N,N,N,J+1);
phis=d3.*c3.*h3;
phis_thetasq=phis;
phis_theta_sum=sum(phis,2);
           
%preparing this for pi (phis over the sum of phis)
A=ones(N,N,N,J+1);
for j=1:J+1
for i=1:N
  A(:,i,:,j)=phis_theta_sum(:,1,:,j);    
end
end

%for pi calculation (SECOND TERM IN THE PRODUCT)
term_1=phis_thetasq./A;
term_1(isnan(term_1)) = 0;

%the phi as "before" (but with Ts rather than T_sq). 
phi_thetasq=phis_theta_sum.^((1-rho)/-theta);
%elevating it to -theta and mult by T
phi_S=phi_thetasq.^(-theta);
%preparing it for pi calculation (extending the l dimension)
phi_S_1=ones(N,N,N,J+1);
for j=1:J+1
    for n=1:N
        phi_S_1(:,n,:,j)=phi_S(:,1,:,j);
    end
end

T2=ones(N,N,N,J+1);
for j=1:J+1
    for n=1:N
        T2(:,:,n,j)=ones(N,N,1,1).*T_mp(n,j);
    end
end
term_2=phi_S_1.*T2;
term_2_sum=sum(term_2,3); 
phi_sq=term_2_sum(:,1,:,:); %For later calculations

%All columns are the same

%ENLARGE i dimension
%--------------------------------
term_3=ones(N,N,N,J+1);
for j=1:J+1
    for n=1:N
        term_3(:,:,n,j)=term_2_sum(:,:,1,j);
    end
end

pi=(term_2./term_3).*term_1;

a1=sum(pi,3);
a1=sum(a1,2);

%--------------------------------------------------------------------------
%Equation 3: phi=sum_l(phis_thetasq). (it correspond to equation xx) 
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%Equation 5: p=gamma*phi_s1^(-1/theta). (it correspond to equation xx) 
%calculating p's (country-industry) (tradables and non-tradables)
%--------------------------------------------------------------------------
p1=gamma_arg.*(phi_sq.^(-1/theta)); %here we start to replace the random number we chose before
p1(isnan(p1)) = 1;

p1=reshape(p1,N,1,J+1);
%p1=(phi_sq.^(-1/theta)); %here we start to replace the random number we chose before
p_sim(:,:,:,s+1)=p1;


%=========================================================================
%Step 5: Calculate Price Index
%=========================================================================
A1=p1.^(1-eta);
A2=ones(N,1,J);
A4=(1/(1-eta));
for j=1:J
A2(:,1,j)=omega(1,j).*A1(:,1,j);
end
A3=sum(A2,3);
P_tradable=A3(:,1).^A4;
P_tradable_si=P_tradable.^si;
P_nontradable=p1(:,1,J+1);
P_nontradable_si=(p1(:,1,J+1).^(1-si));
PIndex=Bn.*(((A3(:,1).^A4)).^si).*(p1(:,1,J+1).^(1-si));
clear A3

%=========================================================================
%Step 6: Compute the final demand (for any country n)
%=========================================================================
Y=ones(N,1,J+1);

%Term 1: (w*L+r*K)/p
%------------------------------------------------
labor_1=ones(N,1,J+1);
    for j=1:J+1
labor_1(:,1,j)=labor;
    end

capital_1=ones(N,1,J+1);
    for j=1:J+1
capital_1(:,1,j)=capital;
    end

term_1=(wages_1(:,1,1:J).*labor_1(:,1,1:J)+r_capital_1(:,1,1:J).*capital_1(:,1,1:J))./p1(:,1,1:J);


%Term 2: [omega*(p)^(1-eta)]/sum(omega(p)^(1-eta))
%------------------------------------------------
term_2=ones(N,1,J);
A1=p1.^(1-eta);
A2=ones(N,1,J);

for j=1:J
A2(:,1,j)=omega(1,j).*A1(:,1,j);
end
A3=sum(A2,3);
for j=1:J
term_2(:,1,j)=A2(:,1,j).*(si./A3);
end
clear A3

Y(:,1,1:J)=term_1.*term_2;
Y(:,1,J+1)=(1-si).*((wages_1(:,1,J+1).*labor_1(:,1,J+1)+r_capital_1(:,1,J+1).*capital_1(:,1,J+1))./p1(:,1,J+1));
clear term_1 term_2


%--------------------------------------------------------------------------
%Equation 8: Trade Shares (Refers to eq. xx in the paper)
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%Equation 9: Production Allocation: Total Demand (Refers to eq. xx in the paper)
%--------------------------------------------------------------------------
%Comment: constructing pi_nl (summing up across i's)

pi_nl=sum(pi,3);
pi_nl=reshape(pi_nl,N,N,J+1);


%Working with the pi's
%----------------------------------------------
pi_1=ones(N,N,J+1);
    for j=1:J+1
    pi_1(:,:,j)=pi_nl(:,:,j)';  
    end

pi_2=ones(N,N*(J+1));
pi_2(:,:)=reshape(pi_1(:,:,:),N,N*(J+1));


pi_3=ones(N*(J+1),N*(J+1));
n=1;
m=N;
for j=1:J+1;
pi_3(n:m,:,:)=pi_2;
 n=n+N;
 m=m+N;
end
clear pi_2


%Working with the betas
%----------------------------------------------
beta_2=1-beta_1;
A=reshape(beta_2,1,1,J+1);
C=ones(N,1,J+1);

for j=1:J+1
C(:,1,j)=ones(N,1)*A(1,1,j);
end
beta_3=reshape(C,1,N*(J+1));

beta_4=ones(N*(J+1),N*(J+1));
for m=1:N*(J+1)
    beta_4(m,:)=beta_3;
end

beta_5=ones(N*(J+1),N*(J+1));
beta_5(:,:)= beta_4;
clear A C beta_2 beta_3 beta_4
  
%Working with the prices
%----------------------------------------------
p2=ones(1,N,J+1);

for j=1:J+1
p2(1,:,j)=p1(:,1,j)';
end
p3=ones(1,N*(J+1));
p3(:,:)=reshape(p2(:,:,:),1,N*(J+1));
p4=ones(N*(J+1),N*(J+1));

for m=1:N*(J+1)
p4(m,:)=p3(:,:);
end
clear p2 p3
 

%Working with the gammas
%----------------------------------------------
gamma_1=kron(gamma_a,ones(N,N));
gamma_2=ones(N*(J+1),N*(J+1));
gamma_2(:,:)=gamma_1;
clear gamma_1


%Constructing the independent variable (expenditure, Q)
%----------------------------------------------
%First: Constructing the term pi*(1-beta)*gamma which is common to all entries
%Notice that these terms equals (1-pi*(1-beta)*gamma) for diagonal elements
term_1=pi_3.*beta_5.*gamma_2;
term_1=term_1*(-1);
B=ones(N*(J+1),N*(J+1));

for r = 1:N*(J+1)
   for c = 1:N*(J+1)
      if r==c
         B(r,c)=1+term_1(r,c);
      else
         B(r,c)=term_1(r,c);
      end
   end
end

%Second: Multiplying the A matrix by the P matrix
A=p4.*B;
clear B

%Making Final Demand (Y) suitable for analysis
%----------------------------------------------
Y2=reshape(Y,N*(J+1),1);

P2=reshape(p1(:,:,:),N*(J+1),1);
B=Y2.*P2;


%Finally computing the total demand
%I can not allow for negative values
%----------------------------------------------
X=linsolve(A,B);

Q=reshape(X,N,1,J+1);


%--------------------------------------------------------------------------
%Equation 8: Compute the factor allocations across sectors as follows (for
%any country n). Note this code includes nontradables
%--------------------------------------------------------------------------
%Computing term_1=sum(p*Q*pi). Notice here I am using the original forms
term_1=ones(N,N,J+1);

for m=1:N
    term_1(:,m,:)=p1(:,1,:).*Q(:,1,:).*pi_nl(:,m,:);
end
term_2=sum(term_1);
term_3=ones(N,1,J+1);
for j=1:J+1
term_3(:,1,j)=term_2(:,:,j)';
end

clear term_1 term_2
labor_sim=(term_3.*alpha_beta_3)./wages_1;
capital_sim=(term_3.*alpha_beta_7)./r_capital_1;
capital_sim(isnan(capital_sim)) = 0;


%Updating the labor and capital from the model for every sector, using the 
%data of total labor and capital in every country n
labor_sum=sum(labor_sim,3);
capital_sum=sum(capital_sim,3);

labor_sim_share=ones(N,1,J+1);
for j=1:J+1
labor_sim_share(:,1,j)=labor_sim(:,1,j)./labor_sum(:,:,:);
end
labor_sim_share(isnan(labor_sim_share)) = 0;

capital_sim_share=ones(N,1,J+1);
for j=1:J+1
capital_sim_share(:,1,j)=capital_sim(:,1,j)./capital_sum(:,:,:);
end
capital_sim_share(isnan(capital_sim_share)) = 0;


%=========================================================================
%Step 10: Update w and r for every n with the feasibility conditions for
%factors L and K
%=========================================================================
labor_adjust=labor_sim_share.*labor_1; 
capital_adjust=capital_sim_share.*capital_1; 
labor_adjust(isnan(labor_adjust)) = 0;
capital_adjust(isnan(capital_adjust)) = 0;

wages_iter=sum((term_3.*alpha_beta_3),3)./labor;
r_capital_iter=sum((term_3.*alpha_beta_7),3)./capital;
r_capital_iter(isnan(r_capital_iter)) = 0;

for n=1:N
   if  wages_iter(n,1)==0;
       wages_iter(n,1)=1;
   end
   if  r_capital_iter(n,1)==0;
       r_capital_iter(n,1)=1;
   end
end
    
wages_sim(:,s+1)=wages_iter;
r_capital_sim(:,s+1)=r_capital_iter;

end;

