%**************************************************************************
%University of British Columbia
%Vanessa Alviarez
%Comparative Advantage
%Journal of International Economics 
%Last Update: 2019
%**************************************************************************

%============================================================================
%Algorithm to solve for absolute productivity adjustment vector Zn. 
%Notice that this procedure is explained in the Appendix E.5 in the paper
%============================================================================
wages=wages_equi;
r_capital=r_capital_equi;
alpha_beta=alpha_1'.*beta_1';
alpha_beta2=(1-alpha_1').*beta_1';


%Calculate the T's 
%--------------------------------------------------------------
%Process in order to solve for the equation with the Zs ignoring second
%order effects. (but taking them into account through an interactive
%method). 

c_eq=reshape(cost,1,N,J+1);
theta_eq=ones(N,N,J+1); 
for j=1:J+1
for n=1:N
theta_eq(n,:,j)=(d(n,:,j).*c_eq(:,:,j)).^(-theta);  
end
end
pq_eq=p1.*Q; 
g_eq=h.^(-theta);
d_eq=d.^(-theta);

%Here I am starting to create the denominator
T_sq=ones(N,J+1);
for j=1:J+1
T_sq(:,j)=g_eq(:,:,j)*T_mp(:,j);
end

term1=ones(N,N,J+1);
for j=1:J+1
for n=1:N
term1(n,:,j)=T_sq(:,j)'.*theta_eq(n,:,j);
end
end
term1_phi=sum(term1,2);
clear term1

term1=pq_eq./term1_phi;
term1(isnan(term1)) = 0;


term2=ones(N,N,J+1);
for n=1:N
for j=1:J+1
  term2(:,n,j)=term1(:,1,j).*theta_eq(:,n,j);
end
end
term2=sum(term2,1);
term2=reshape(term2,N,1,J+1);

term3=ones(N,N,J+1);
for n=1:N
for j=1:J+1
  term3(:,n,j)=term2(:,1,j).*g_eq(:,n,j);
end
end

term4=ones(N,N,J+1);
for j=1:J+1
    for n=1:N
  term4(n,:,j)=T_mp_ref(:,j)'.*term3(n,:,j);
    end
end
term5=sum(term4,3);

%Labor:
term6=ones(N,1,J+1);
for j=1:J+1
term6(:,1,j)=labor_adjust(:,1,j)./alpha_beta(1,j);
end

term7=ones(N,1,J+1);
for j=1:J+1
term7(:,1,j)=wages(:,1).*term6(:,1,j); 
end

%Capital:
term8=ones(N,1,J+1);
for j=1:J+1
term8(:,1,j)=capital_adjust(:,1,j)./alpha_beta2(1,j);
end
term9=ones(N,1,J+1);
for j=1:J+1
term9(:,1,j)=r_capital(:,1).*term8(:,1,j); 
end
term7=sum(term7,3);
term9=sum(term9,3);

A=term5;
B=term9;

lb=zeros(N,1);
Aeq=zeros(1,N);
Aeq(1,ref)=1;
beq=1;
options = optimset('LargeScale','off');

A=term5;
B=term7;
X_labor= lsqlin(A,B,[],[],[],[],lb,[],[],[]);

%-------------------------------------------------------
Z=ones(N,J+1);
for j=1:J+1
   Z(:,j)=X_labor./X_labor(ref,1);
end
T_mp=Z.*T_mp_ref;

wages_equi=wages_equi./X_labor(ref,1);
r_capital_equi=r_capital_equi./X_labor(ref,1);


%-------------------------------------------------------




