%==========================================================================%
%Aggregates GAMMA and BETAS (value added) in the equilibrium for (all tradable) and
%non-tradable
%Parameters for the one sectoral model 
%==========================================================================%



%-------------------------------------------------------------------------%
%Betas (to compare with the original betas. Notice this betas are also different across countries)
%-------------------------------------------------------------------------%
va=ones(N,1,J+1);
output=ones(N,1,J+1);
for j=1:J+1
va(:,1,j)=(wages.*labor_adjust(:,1,j)+r_capital.*capital_adjust(:,1,j));
output(:,1,j)=p1(:,1,j).*Q(:,1,j);
end
betas_nj=va./output; %This has to be calculated with data
betas_nj=reshape(betas_nj,N,J+1); 

%Overall Value Added for each country
output_sum=sum(output(:,1,1:J+1),3);
va_sum=sum(va(:,1,1:J+1),3);
va_share=va_sum./output_sum;
beta_all=va_share;

%Overall Value Added for each country (Tradable and Non Tradable)
output_sum=sum(output(:,1,1:J),3);
va_sum=sum(va(:,1,1:J),3);
va_share=va_sum./output_sum;
beta_T=va_share;
beta_NT=va(:,1,J+1)./output(:,1,J+1);
beta_T_NT=[beta_T beta_NT];
beta_T_NT_mean=mean(beta_T_NT,1);

%Production Shares 
%----------------------------------------------------
output_sum=sum(output(:,1,1:J),3);
output_share=ones(N,1,J);
for j=1:J
output_share(:,1,j)=output(:,1,j)./output_sum(:,1);
end
output_share_T=reshape(output_share,N,J);

output_sum=sum(output(:,1,1:J+1),3);
output_share=ones(N,1,J+1);
for j=1:J+1
output_share(:,1,j)=output(:,1,j)./output_sum(:,1);
end
output_share_all=reshape(output_share,N,J+1);



%-------------------------------------------------------------------------%
%Average Productivities
%-------------------------------------------------------------------------%
T_agg_all=ones(N,1); 
for n=1:N
T_agg_all(n,1)=output_share_all(n,:)*(T_mp(n,:))';
end
T_agg_all_savg=mean(T_mp,2); 

T_agg_all_geo=ones(N,1); 
for n=1:N
T_agg_all_geo(n,1)=prod((T_mp(n,:)).^(output_share_all(n,:)),2);
end

T_agg_all_T=ones(N,1); 
for n=1:N
T_agg_all_T(n,1)=output_share_T(n,1:J)*(T_mp(n,1:J))';
end

T_agg_all_T_savg=mean(T_mp(:,1:J),2); 


%-------------------------------------------------------------------------%
%Average g's (MP barriers) FIRST BILATERAL
%-------------------------------------------------------------------------%
mp_ls=sum(mp_lsj,3); 
mp_ls_weight=ones(N,N,J+1); 
for j=1:J+1
mp_ls_weight(:,:,j)=mp_lsj(:,:,j)./mp_ls;
end
mp_ls_weight(isnan(mp_ls_weight)) = 0;
sum(mp_ls_weight,3);

h_mp2=h_mp; 
for j=1:J+1
for l=1:N
    for s=1:n
        if l==s
   h_mp2(l,s,j)=0;
        end
         if h_mp2(l,s,j)==Inf
   h_mp2(l,s,j)=0;
        end
    end
end
end

temp=mp_ls_weight.*(h_mp2);
h_agg=sum(temp,3);
h_agg2=h_agg;
for l=1:N
    for s=1:n

         if h_agg2(l,s)==0
   h_agg2(l,s)=Inf;
         end
        
         if l==s
   h_agg2(l,s)=1;
         end
    end
end
h_agg=h_agg2; 
clear h_agg2

%now lets impute this h to all entries with positive MP flows (except the diagonal)
h_agg2=h_mp;
for j=1:J+1
for l=1:N
    for s=1:n

         if h_mp(l,s,j)==1000
   h_agg2(l,s,j)=Inf;
         end
         
         if h_mp(l,s,j)~=1000
   h_agg2(l,s,j)=1;
         end
        
         if l==s
   h_agg2(l,s,j)=1;
         end
    end
end
end
h_agg3=ones(N,N,J+1);
for j=1:J+1
    h_agg3(:,:,j)=h_agg2(:,:,j).*h_agg;
end
h_agg3(isnan(h_agg3)) = 1000;
h_agg=h_agg3;
clear h_agg2 h_agg3

%-------------------------------------------------------------------------%
%COUNTRY LEVEL 
%notice that this will not be impossed to all the matrix (only in those cases with positive MP flows in the 
%original equilibrium 
%-------------------------------------------------------------------------%
h_mp2=h_mp; 
for j=1:J+1
for l=1:N
    for s=1:n
        if l==s
   h_mp2(l,s,j)=0;
        end
         if h_mp2(l,s,j)==1000
   h_mp2(l,s,j)=0;
        end
    end
end
end
hlj=sum(mp_share_lsj.*h_mp2,2); %but befor assumming them up across different sources I have to avoid myself, I think
hlj=reshape(hlj,N,J+1);
hl=sum(mp_share_lj.*hlj,2);

%Now lets impute this h to all entries with positive MP flows (except the diagonal)
h_agg2=h_mp;
for j=1:J+1
for l=1:N
    for s=1:n

         if h_mp(l,s,j)==1000
   h_agg2(l,s,j)=Inf;
         end
         
         if h_mp(l,s,j)~=1000
   h_agg2(l,s,j)=1;
         end
        
         if l==s
   h_agg2(l,s,j)=1;
         end
    end
end
end
h_agg3=ones(N,N,J+1);
for j=1:J+1
    for s=1:N
    h_agg3(:,s,j)=h_agg2(:,s,j).*hl;
    end
end
h_agg3(isnan(h_agg3)) = 1000;
h_agg_v2=h_agg3;
for l=1:N
    for s=1:N
         if l==s
   h_agg_v2(l,s,:)=1;
         end
    end
end
clear h_agg2 h_agg3


%-------------------------------------------------------------------------%
%Average d's (trade barriers) FIRST BILATERAL
%-------------------------------------------------------------------------%
trade_nl=sum(trade_nlj,3); 
trade_nl_weight=ones(N,N,J+1); 
for j=1:J+1
trade_nl_weight(:,:,j)=trade_nlj(:,:,j)./trade_nl;
end
trade_nl_weight(isnan(trade_nl_weight)) = 0;
sum(trade_nl_weight,3);

d_trade2=d_trade; 
for j=1:J+1
for l=1:N
    for s=1:n
        if l==s
   d_trade2(l,s,j)=0;
        end
         if d_trade2(l,s,j)==1000
   d_trade2(l,s,j)=0;
        end
    end
end
end

temp=trade_nl_weight.*(d_trade2);
d_agg=sum(temp,3);
d_agg2=d_agg;
for l=1:N
    for s=1:n

         if d_agg2(l,s)==0
   d_agg2(l,s)=Inf;
         end
        
         if l==s
   d_agg2(l,s)=1;
         end
    end
end
d_agg=d_agg2; 
clear d_agg2

%now lets impute this h to all entries with positive MP flows (except the diagonal)
d_agg2=d_trade;
for j=1:J+1
for l=1:N
    for s=1:n

         if d_trade(l,s,j)==1000
   d_agg2(l,s,j)=Inf;
         end
         
         if d_trade(l,s,j)~=1000
   d_agg2(l,s,j)=1;
         end
        
         if l==s
   d_agg2(l,s,j)=1;
         end
    end
end
end
d_agg3=ones(N,N,J+1);
for j=1:J+1
    d_agg3(:,:,j)=d_agg2(:,:,j).*d_agg;
end
d_agg3(isnan(d_agg3)) = 1000;
d_agg=d_agg3;
clear d_agg2 d_agg3

%-------------------------------------------------------------------------%
%COUNTRY LEVEL 
%notice that this will not be impossed to all the matrix (only in those cases with positive MP flows in the 
%original equilibrium 
%-------------------------------------------------------------------------%
d_mp2=d_trade; 
for j=1:J+1
for l=1:N
    for s=1:n
        if l==s
   d_mp2(l,s,j)=0;
        end
         if d_mp2(l,s,j)==1000
   d_mp2(l,s,j)=0;
        end
    end
end
end
dnj=sum(trade_share_nlj.*d_mp2,2); 
dnj=reshape(dnj,N,J+1);
dn=sum(trade_share_nj.*dnj,2);

%now lets impute this h to all entries with positive MP flows (except the diagonal)
d_agg2=d_trade;
for j=1:J+1
for l=1:N
    for s=1:n

         if d_trade(l,s,j)==1000
   d_agg2(l,s,j)=1000;
         end
         
         if d_trade(l,s,j)~=1000
   d_agg2(l,s,j)=1;
         end
        
         if l==s
   d_agg2(l,s,j)=1;
         end
    end
end
end
d_agg3=ones(N,N,J+1);
for j=1:J+1
    for s=1:N
    d_agg3(:,s,j)=d_agg2(:,s,j).*hl;
    end
end
d_agg3(isnan(d_agg3)) = 1000;
d_agg_v2=d_agg3;
for l=1:N
    for s=1:N
         if l==s
   d_agg_v2(l,s,:)=1;
         end
    end
end
clear d_agg2 d_agg3


%-------------------------------------------------------------------------%
%Gammas
%-------------------------------------------------------------------------%
gamma_uni_1=sum(gamma_a(1:J,:),1);
gamma_uni_2=[gamma_uni_1;gamma_a(J+1,:)];
output_share_median=mean(output_share_T,1);
gamma_uni_3=gamma_uni_2(1,1:J)*output_share_median';
gamma_uni_4=gamma_uni_2(2,1:J)*output_share_median';
gamma_uni=ones(2,2);
gamma_uni(1,1)=gamma_uni_3;
gamma_uni(2,1)=gamma_uni_4;
gamma_uni(1,2)=gamma_uni_2(1,end);
gamma_uni(2,2)=gamma_uni_2(2,end);
clear gamma_uni_1 gamma_uni_2 gamma_uni_3 gamma_uni_4

%Construct the B matrix
gamma_uni_tran=gamma_uni';
beta_uni_tran=(1-beta_T_NT_mean)';

Bj=ones(2,2);
for j=1:2
   Bj(:,j)=gamma_uni_tran(:,j).*beta_uni_tran(:,1);
end
Cj=inv(eye(2,2)-Bj);

si_uni=[si (1-si)];
D_uni=ones(N,2);
for j=1:2
D_uni(:,j)=si_uni*Cj(:,j);
end


%-------------------------------------------------------------------------%
%For a multisectoral model
%-------------------------------------------------------------------------%
%Construct the B matrix
gamma_multi_tran=gamma_a';
beta_multi_tran=(1-beta_1);

Bj=ones(J+1,J+1);
for j=1:J+1
Bj(:,j)=gamma_multi_tran(:,j).*beta_multi_tran(:,1);
end
Cj=inv(eye(J+1,J+1)-Bj);

si_multi=ones(N,J);
for j=1:J
si_multi(:,j)=si.*omega(1,j);
end
si_multi=[si_multi (1-si)];

D_multi=ones(N,J+1);
for j=1:J+1
D_multi(:,j)=si_multi*Cj(:,j);
end

%-------------------------------------------------------------------------%
%For a multisectoral model (no interlinkages, intermediate inputs only)
%-------------------------------------------------------------------------%
Bj=ones(J+1,J+1);
prov=eye(J+1,J+1);
for j=1:J+1
Bj(:,j)=prov(:,j).*beta_multi_tran(:,1);
end
Cj=inv(eye(J+1,J+1)-Bj);

D_multi_nolink=ones(N,J+1);
for j=1:J+1
D_multi_nolink(:,j)=si_multi*Cj(:,j);
end