addpath('L:\Dropbox (UBC-Umich)\MNC_CA\Data and Replication Files\matlab_code')

%----------------------------------------------------------
%Evaluating Model Fit
%----------------------------------------------------------
%Wages, Return of Capital 
wages_model=wages_equi./wages_equi(1,1);
wages_comparison=[wages_model wages_rel_data];
mean(wages_comparison)
median(wages_comparison)
corr(wages_comparison(:,1),wages_comparison(:,2))

figure
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(wages_comparison(:,1),wages_comparison(:,2))
scatter(wages_comparison(:,1),wages_comparison(:,2),'b','*')
line([0,1.6],[0,1.6],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
ylabel('Wages Relative to U.S. (Data)');
xlabel('Wages Relative to U.S. (Model)');
%title('Model Fit');
set(gcf,'color','w');
labelpoints(wages_comparison(:,1),wages_comparison(:,2), labels, 'FontSize', 8);
saveas(gcf,'modelfit_wages.png')

%---------------------------------------------------------------------
%Bring:  
%Inward as a fraction of Output (all and manuf)
%Outward as a fraction of Output (all and manuf)
%Imports as a fraction of Output
%---------------------------------------------------------------------
%outsheet isiccodereporter imports_loc_manuf imports_loc MP_share_inward_manuf MP_share_outward_manuf MP_share_inward  MP_share_outward  using "${MP_CA_matlab}/mp_inward_outward_share", comma nonames nolabel replace


load mp_inward_outward_share.out
imports_data=reshape(mp_inward_outward_share(:,2),N,1);
imports_data_all=reshape(mp_inward_outward_share(:,3),N,1);
mp_inward_data=reshape(mp_inward_outward_share(:,4),N,1);
mp_outward_data=reshape(mp_inward_outward_share(:,5),N,1);
mp_inward_data_all=reshape(mp_inward_outward_share(:,6),N,1);
mp_outward_data_all=reshape(mp_inward_outward_share(:,7),N,1);
clear mp_inward_outward_share


%----------------------------------------------------------
%Imports 
%----------------------------------------------------------
pi_diag=pi_nl;
for j=1:J
for r=1:N
    for n=1:N
    if r==n
    pi_diag(r,n,j)=0;
    end
    end
end
end

pi_imp=ones(N,1,J);
for j=1:J
 pi_imp(:,1,j)=sum(pi_diag(:,:,j),2);
end

%Constructing P*Q
pq=p1(:,:,1:J).*Q(:,:,1:J);

%Constructing Imports per industry j
M=pq.*pi_imp;

%Constructing Total Imports
M_total=reshape(M,N,J);
M_total_2=sum(M_total,2);
output=sum(pq,3);
M_share=M_total_2./output; 
clear M_total_2
imports_comparison=[M_share imports_data];
mean(imports_comparison)
median(imports_comparison)
corr(imports_comparison(:,1),imports_comparison(:,2))


figure
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(imports_comparison(:,1),imports_comparison(:,2))
scatter(imports_comparison(:,1),imports_comparison(:,2),'b','*')
line([0,0.7],[0,0.7],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
ylabel('Imports/Output (Data)');
xlabel('Imports/Output (Model)');
set(gcf,'color','w');
labelpoints(imports_comparison(:,1),imports_comparison(:,2), labels, 'FontSize', 8);
saveas(gcf,'modelfit_imports.png')




%----------------------------------------------------------
%Inward Manuf
%----------------------------------------------------------
pq=p1(:,:,1:J).*Q(:,:,1:J);

pi_1=pi;
for j=1:J
    for n=1:N
        for l=1:N
            for i=1:N
                if l==i
               pi_1(n,l,i,j)=0;
                end
            end
        end
    end
end

pi_product=ones(N,N,N,J);
for j=1:J
    for l=1:N
        for i=1:N
 pi_product(:,l,i,j)=pi_1(:,l,i,j).*pq(:,:,j);
        end
    end
end
pi_product_sum=sum(pi_product,1);
pi_product_sum_2=sum(pi_product_sum,3);
pi_product_sum_3=sum(pi_product_sum_2,4);
output=sum(pq,3);
MP_inward_output=pi_product_sum_3'./output;
clear pi_product_sum pi_product_sum_2 pi_product_sum_3
mp_inward_comparison_manuf=[MP_inward_output mp_inward_data];
mean(mp_inward_comparison_manuf)
median(mp_inward_comparison_manuf)
corr(mp_inward_comparison_manuf(:,1),mp_inward_comparison_manuf(:,2))


figure
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(mp_inward_comparison_manuf(:,1),mp_inward_comparison_manuf(:,2))
scatter(mp_inward_comparison_manuf(:,1),mp_inward_comparison_manuf(:,2),'b','*')
line([0,0.7],[0,0.7],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
ylabel('Inward MP/Output (Data)');
xlabel('Inward MP/Output (Model)');
set(gcf,'color','w');
labelpoints(mp_inward_comparison_manuf(:,1),mp_inward_comparison_manuf(:,2), labels, 'FontSize', 8);
saveas(gcf,'modelfit_mp_inward_manuf.png')



%Inward All data
%----------------------------------------------------------
pq=p1(:,:,1:J+1).*Q(:,:,1:J+1);

pi_1=pi;
for j=1:J+1
    for n=1:N
        for l=1:N
            for i=1:N
                if l==i
               pi_1(n,l,i,j)=0;
                end
            end
        end
    end
end

pi_product=ones(N,N,N,J+1);
for j=1:J+1
    for l=1:N
        for i=1:N
 pi_product(:,l,i,j)=pi_1(:,l,i,j).*pq(:,:,j);
        end
    end
end
pi_product_sum=sum(pi_product,1);
pi_product_sum_2=sum(pi_product_sum,3);
pi_product_sum_3=sum(pi_product_sum_2,4);
output=sum(pq,3);
MP_inward_output=pi_product_sum_3'./output;
clear pi_product_sum pi_product_sum_2 pi_product_sum_3
mp_inward_comparison_all=[MP_inward_output mp_inward_data_all];
mean(mp_inward_comparison_all)
median(mp_inward_comparison_all)
corr(mp_inward_comparison_all(:,1),mp_inward_comparison_all(:,2))
scatter(mp_inward_comparison_all(:,1),mp_inward_comparison_all(:,2))


figure
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
corr(mp_inward_comparison_all(:,1),mp_inward_comparison_all(:,2))
scatter(mp_inward_comparison_all(:,1),mp_inward_comparison_all(:,2),'b','*')
line([0,0.7],[0,0.7],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
ylabel('Inward MP/Output (Data)');
xlabel('Inward MP/Output (Model)');
set(gcf,'color','w');
labelpoints(mp_inward_comparison_all(:,1),mp_inward_comparison_all(:,2), labels, 'FontSize', 8);
saveas(gcf,'modelfit_mp_inward_all.png')





%Outward Manuf
%----------------------------------------------------------
pq=p1(:,:,1:J).*Q(:,:,1:J);

pi_1=pi;
for j=1:J
    for n=1:N
        for l=1:N
            for i=1:N
                if l==i
               pi_1(n,l,i,j)=0;
                end
            end
        end
    end
end

pi_product=ones(N,N,N,J);
for j=1:J
    for l=1:N
        for i=1:N
 pi_product(:,l,i,j)=pi_1(:,l,i,j).*pq(:,:,j);
        end
    end
end

pi_product_sum=sum(pi_product,1);
pi_product_sum_2=sum(pi_product_sum,2);
pi_product_sum_3=sum(pi_product_sum_2,4);
output=sum(pq,3);
MP_outward_output=reshape(pi_product_sum_3,N,1)./output;
clear pi_product_sum pi_product_sum_2 pi_product_sum_3
mp_outward_comparison_manuf=[MP_outward_output mp_outward_data];
mean(mp_outward_comparison_manuf)
median(mp_outward_comparison_manuf)
corr(mp_outward_comparison_manuf(:,1),mp_outward_comparison_manuf(:,2))

figure
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
%corr(mp_inward_comparison_manuf(:,1),mp_inward_comparison_manuf(:,2))
scatter(mp_outward_comparison_manuf(:,1),mp_outward_comparison_manuf(:,2),'b','*')
line([0,1],[0,1],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
ylabel('Outward MP/Output (Data)');
xlabel('Outward MP/Output (Model)');
set(gcf,'color','w');
labelpoints(mp_outward_comparison_manuf(:,1),mp_outward_comparison_manuf(:,2), labels, 'FontSize', 8);
saveas(gcf,'modelfit_mp_outward_manuf.png')



%Outward All data
%----------------------------------------------------------
pq=p1(:,:,1:J+1).*Q(:,:,1:J+1);

pi_1=pi;
for j=1:J+1
    for n=1:N
        for l=1:N
            for i=1:N
                if l==i
               pi_1(n,l,i,j)=0;
                end
            end
        end
    end
end

pi_product=ones(N,N,N,J+1);
for j=1:J+1
    for l=1:N
        for i=1:N
 pi_product(:,l,i,j)=pi_1(:,l,i,j).*pq(:,:,j);
        end
    end
end
pi_product_sum=sum(pi_product,1);
pi_product_sum_2=sum(pi_product_sum,2);
pi_product_sum_3=sum(pi_product_sum_2,4);
output=sum(pq,3);
MP_outward_output=reshape(pi_product_sum_3,N,1)./output;
clear pi_product_sum pi_product_sum_2 pi_product_sum_3
mp_outward_comparison_all=[MP_outward_output mp_outward_data_all];
mean(mp_outward_comparison_all)
median(mp_outward_comparison_all)
corr(mp_outward_comparison_all(:,1),mp_outward_comparison_all(:,2))
scatter(mp_outward_comparison_all(:,1),mp_outward_comparison_all(:,2))


figure
labels={'USA', 'AUS', 'AUT', 'BEL', 'BGR', 'CAN', 'CZE', 'DNK', 'EST', 'FIN', 'FRA', 'DEU', 'GRC', 'HUN', 'ITA', 'JPN', 'LVA', 'LTU', 'MEX', 'NLD', 'NZL', 'NOR', 'POL', 'PRT', 'ROM', 'RUS', 'SVK', 'ESP', 'SWE', 'TUR', 'UKR', 'GBR'};
scatter(mp_outward_comparison_all(:,1),mp_outward_comparison_all(:,2),'b','*')
line([0,1],[0,1],...
 'linewidth',2,...
 'color',[1,0,0]);
axis square;
ylabel('Outward MP/Output (Data)');
xlabel('Outward MP/Output (Model)');
set(gcf,'color','w');
labelpoints(mp_outward_comparison_all(:,1),mp_outward_comparison_all(:,2), labels, 'FontSize', 8);
saveas(gcf,'modelfit_mp_outward_all.png')
